// Generated by CoffeeScript 1.10.0
var basicAuth, connect, favicons, log, logger, markdown, middleware, path, serveIndex, serveStatic, url;

basicAuth = require('basic-auth-connect');

connect = require('connect');

favicons = require('connect-favicons');

logger = require('morgan');

path = require('path');

serveIndex = require('serve-index');

serveStatic = require('serve-static');

url = require('url');

log = require('./log');

markdown = require('./markdown');

middleware = require('./middleware');

module.exports = {
  createServer: function(opts) {
    var app, ref, serve, server;
    if (opts == null) {
      opts = {};
    }
    if (opts.host == null) {
      opts.host = '0.0.0.0';
    }
    if (opts.port == null) {
      opts.port = 1987;
    }
    if (opts.staticDir == null) {
      opts.staticDir = process.cwd();
    }
    opts.fallback = '/' + ((ref = opts.fallback) != null ? ref : '').replace(/^[.\/]+/, '');
    app = connect();
    app.use(function(req, res, next) {
      url = url.parse(req.url);
      req.path = url.pathname;
      req.search = url.search;
      return next();
    });
    app.use(favicons(__dirname + '/../assets'));
    app.use(logger('dev'));
    if (opts.user && opts.pass) {
      app.use(basicAuth(opts.user, opts.pass));
    }
    app.use(middleware());
    app.use(markdown());
    serve = serveStatic(opts.staticDir, {
      dotfiles: 'deny',
      etag: false,
      extensions: ['html', 'htm'],
      fallthrough: true,
      index: ['index.html', 'index.htm']
    });
    app.use(serve);
    app.use(serveIndex(opts.staticDir, {
      hidden: true
    }));
    app.use(function(req, res, next) {
      var ext, ref1;
      ext = path.extname(req.path);
      if (!opts.fallback) {
        return next();
      }
      if (!((ext === '') || /\.html?/.test(ext))) {
        return next();
      }
      req.url = opts.fallback + ((ref1 = req.search) != null ? ref1 : '');
      delete req._parsedUrl;
      delete req._parsedOriginalUrl;
      return serve(req, res, next);
    });
    server = require('http').createServer(app);
    server.setMaxListeners(100);
    server.on('listening', function() {
      var cwd, dir;
      cwd = process.cwd();
      dir = path.basename(cwd);
      return log.bebop("serving " + dir + " at http://" + opts.host + ":" + opts.port);
    });
    server.run = function(cb) {
      if (cb == null) {
        cb = function() {};
      }
      process.once('uncaughtException', function(err) {
        if (err.code === 'EADDRINUSE') {
          log.error('address in use, retrying...');
          server.close();
          opts.port++;
          return setTimeout(server.run, 1000);
        } else {
          console.log(err);
          console.log(err.stack);
          return process.exit(1);
        }
      });
      return server.listen(opts.port, opts.host, cb);
    };
    return server;
  }
};
